#include <stdio.h>
#include <mpi.h>

  int main(int argc, char ** argv) 
  {
    int size,rank;
    int length;
    char name[80];
    
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&rank);
    MPI_Comm_size(MPI_COMM_WORLD,&size);
    MPI_Get_processor_name(name,&length);


    int dest = 0;
    int tag = 999;
    if (rank != 0 ) { /* I’m a client */
      printf(" I am client with rank %d on %s \n", rank, name);
      MPI_Send(name,80,MPI_CHAR,dest,tag,MPI_COMM_WORLD);

   }
  
    else { /* I’m the server (rank == 0) */

      printf(" I am server with rank %d on %s \n", rank, name);  
      
      MPI_Status status;
      int source;
      for(source = 1; source < size; source++) {
      MPI_Recv(name,80,MPI_CHAR,source,tag,MPI_COMM_WORLD,&status);
      printf(" Message from %d of %d on %s\n",source,size,name);
     
           
      }
      
 }

 MPI_Finalize();
 return 0;
}


